## gtirb-pprinter-8447ac93d10d459cdfecb9b6212fe59d2e9c00f7.tar.gz

=== CMakeLists.txt ===
#
# Cmake Configuration
#

# Need 3.12.1 to support FindPython3 and the correct cpack semantics for version
# numbers.
cmake_minimum_required(VERSION 3.12.1)

project(gtirb_pprinter)
set(PACKAGE_BRANCH master)

# get version information
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/version.txt" ver)

string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
set(GTIRB_PPRINTER_MAJOR_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
set(GTIRB_PPRINTER_MINOR_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
set(GTIRB_PPRINTER_PATCH_VERSION ${CMAKE_MATCH_1})

set(GTIRB_PPRINTER_VERSION
    "${GTIRB_PPRINTER_MAJOR_VERSION}.${GTIRB_PPRINTER_MINOR_VERSION}.${GTIRB_PPRINTER_PATCH_VERSION}"
    CACHE STRING "version of gtirb-pprinter" FORCE)

if(NOT DEFINED GTIRB_PPRINTER_BUILD_REVISION)
  execute_process(
    COMMAND git log --pretty=format:%h -n 1
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    OUTPUT_VARIABLE GTIRB_PPRINTER_BUILD_REVISION
    ERROR_QUIET)
endif()
if(GTIRB_PPRINTER_BUILD_REVISION STREQUAL "")
  set(GTIRB_PPRINTER_BUILD_REVISION "UNKNOWN")
endif()
option(GTIRB_PPRINTER_RELEASE_VERSION
       "Whether or not to build Python package versions without dev suffixes."
       OFF)

string(TIMESTAMP GTIRB_PPRINTER_BUILD_DATE "%Y-%m-%d")

# includes
include(CheckFunctionExists)
include(CheckCXXSourceCompiles)
include(CheckIncludeFile)

option(ENABLE_CONAN "Use Conan to inject dependencies" OFF)
if(ENABLE_CONAN)
  set(CONAN_SYSTEM_INCLUDES ON)
  include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup()
endif()

# ---------------------------------------------------------------------------
# Global settings
# ---------------------------------------------------------------------------

option(GTIRB_PPRINTER_ENABLE_TESTS "Enable building and running tests." ON)

# The libraries can be static while the drivers can link in other things in a
# shared manner. This option allows for this possibility.
option(
  GTIRB_PPRINTER_STATIC_DRIVERS
  "Attempt to make any driver executables as statically-linked as possible.
Implies GTIRB_PPRINTER_BUILD_SHARED_LIBS=OFF."
  OFF)

if(GTIRB_PPRINTER_STATIC_DRIVERS)
  set(Boost_USE_STATIC_LIBS ON)

  if(WIN32)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
  else()
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  endif()
endif()

# This just sets the builtin BUILD_SHARED_LIBS, but if defaults to ON instead of
# OFF.
option(GTIRB_PPRINTER_BUILD_SHARED_LIBS "Build shared libraries." ON)

if(GTIRB_PPRINTER_STATIC_DRIVERS OR NOT GTIRB_PPRINTER_BUILD_SHARED_LIBS)
  set(BUILD_SHARED_LIBS OFF)
else()
  set(BUILD_SHARED_LIBS ON)
endif()

option(GTIRB_PPRINTER_CODE_COVERAGE
       "Build with instrumentation for collecting code coverage" OFF)

if(GTIRB_PPRINTER_CODE_COVERAGE)
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL GNU OR ${CMAKE_CXX_COMPILER_ID} STREQUAL
                                              Clang)
    add_compile_options(--coverage)
    # Unfortunately using link_libraries for this triggers a warning about
    # CMP0022 not being set inside of googletest. add_link_options does not
    # trigger this warning, but is only available in CMake 3.13+.
    if(${CMAKE_VERSION} GREATER_EQUAL "3.13")
      add_link_options(--coverage)
    else()
      link_libraries(--coverage)
    endif()
  else()
    message(FATAL_ERROR "no support for code coverage on this target")
  endif()
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src)
if(WIN32)
  set(CMAKE_DEBUG_POSTFIX
      "d"
      CACHE STRING "add a postfix, usually d on windows")
endif()
set(CMAKE_RELEASE_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_RELWITHDEBINFO_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_MINSIZEREL_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Determine whether or not to strip debug symbols and set the build-id. This is
# only really needed when we are building ubuntu *-dbg packages
option(GTIRB_PPRINTER_STRIP_DEBUG_SYMBOLS
       "Whether or not to strip debug symbols and set the build-id." OFF)

# Use C++17
set(CMAKE_CXX_STANDARD 17)
# Error if it's not available
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Specifically check for gcc-7 or later. gcc-5 is installed on many systems and
# will accept -std=c++17, but does not fully support the standard.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "7.0.0")
    message(FATAL_ERROR "gcc 7 or later is required to build gtirb")
  endif()
endif()

# If we're using libc++, we need to manually include libc++abi (unlike with
# using libstdc++, which automatically does this)
include(CheckCXXSourceCompiles)

check_cxx_source_compiles(
  "
  #include <ciso646>
  int main() {
    return _LIBCPP_VERSION;
  }
"
  USING_LIBCPP)

if(USING_LIBCPP)
  if(BUILD_SHARED_LIBS)
    find_library(LIBCPP_ABI NAMES c++abi)
  else()
    find_library(LIBCPP_ABI NAMES libc++abi.a)
  endif()

  if(NOT LIBCPP_ABI)
    message(FATAL_ERROR "libc++abi not found")
  endif()
endif()

# Required warning suppression (TODO: Remove!)
if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
  # add_compile_options(-wd4251)  # Non-exportable template classes.
elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL GNU)
  add_compile_options(-mtune=generic)
  add_compile_options(-pthread)
elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
  add_compile_options(-mtune=generic)
  add_compile_options(-pthread)
endif()

# If Unix, but not Cygwin: Find system libs we need to link with.
if(UNIX)
  if(NOT WIN32)
    set(SYSLIBS ${SYSLIBS} dl pthread)
  endif()
else()
  set(SYSLIBS)
endif()

# global MSVC options
if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
  add_compile_options(-D_CRT_SECURE_NO_WARNINGS)
  add_compile_options(-D_MBCS)
  add_compile_options(-D_SCL_SECURE_NO_WARNINGS)
  add_compile_options(-D_WIN32)
  add_compile_options(-D_WINDOWS)
  add_compile_options(-DMBCS)
  add_compile_options(-DNOMINMAX)
  add_compile_options(-EHsc)
  add_compile_options(-GR)
  add_compile_options(-MP)
  add_compile_options(-nologo)
  add_compile_options(-W4)
  add_compile_options(-WX)

  add_compile_options(
    -wd4267) # Conversion warning.  Appears in gtirb's proto headers, but only
             # when building with conan. Unfortunately, this is the only way to
             # get it to go away it seems.
  add_compile_options(
    -wd4251) # 'identifier' : class 'type' needs to have dll- interface to be
             # used by clients of class 'type2'
  add_compile_options(-wd4275) # Non-dll interface base classes.
  add_compile_options(-wd4996) # VC8: Deprecated libc functions.
  add_compile_options(
    -wd4351) # This is a warning about a change in behavior from old versions of
             # visual c++.  We want the new (standard-compliant) behavior, so we
             # don't want the warning.  The warning is that using an array in a
             # class initializer list will cause its elements to be default
             # initialized.

  # Per-configuration options
  add_compile_options($<$<CONFIG:Debug>:-D_DEBUG>)
  add_compile_options($<$<CONFIG:Debug>:-DDEBUG>)
  add_compile_options($<$<CONFIG:Debug>:-MDd>)
  add_compile_options($<$<CONFIG:Debug>:-Ob0>) # Disables inline expansion
  add_compile_options(
    $<$<CONFIG:Debug>:-Od>) # Disables optimization, speeding compilation and
                            # simplifying debugging.
                            # https://msdn.microsoft.com/en-
                            # us/library/k1ack8f1.aspx
  add_compile_options($<$<CONFIG:Debug>:-RTC1>) # Enables run-time error
                                                # checking.
  add_compile_options($<$<CONFIG:Debug>:-W4>) # Sets warning level.
  add_compile_options($<$<CONFIG:Debug>:-Zi>) # Generates complete debugging
                                              # information.
  add_compile_options($<$<CONFIG:Debug>:-bigobj>) # enables big obj compilation
                                                  # option

  add_compile_options($<$<CONFIG:RelWithDebInfo>:-D_NDEBUG>)
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-DNDEBUG>)
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-MD>)
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-O2>) # Creates fast code.
  add_compile_options(
    $<$<CONFIG:RelWithDebInfo>:-Ob2>) # The default value. Allows expansion of
                                      # functions marked as inline, __inline, or
                                      # __forceinline, and any other function
                                      # that the compiler chooses.
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-Oi>) # Generates intrinsic
                                                       # functions.
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-Ot>) # Favors fast code.
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-W4>) # Sets warning level.
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-Zi>) # Generates complete
                                                       # debugging information.
  add_compile_options($<$<CONFIG:RelWithDebInfo>:-bigobj>) # enables big obj
                                                           # compilation option

  add_compile_options($<$<CONFIG:Release>:-D_NDEBUG>)
  add_compile_options($<$<CONFIG:Release>:-DNDEBUG>)
  add_compile_options($<$<CONFIG:Release>:-MD>)
  add_compile_options($<$<CONFIG:Release>:-O2>) # Creates fast code.
  add_compile_options(
    $<$<CONFIG:Release>:-Ob2>) # The default value. Allows expansion of
                               # functions marked as inline, __inline, or
                               # __forceinline, and any other function that the
                               # compiler chooses.
  add_compile_options($<$<CONFIG:Release>:-Oi>) # Generates intrinsic functions.
  add_compile_options($<$<CONFIG:Release>:-Ot>) # Favors fast code.
  add_compile_options($<$<CONFIG:Release>:-W4>) # Sets warning level.
  add_compile_options($<$<CONFIG:Release>:-bigobj>) # enables big obj
                                                    # compilation option

  # Shove in some linker flags to support using 64-bit memory. 4099 -PDB
  # 'filename' was not found with 'object/library' or at 'path'; linking object
  # as if no debug info
  set(CMAKE_SHARED_LINKER_FLAGS
      "${CMAKE_SHARED_LINKER_FLAGS} /LARGEADDRESSAWARE")

elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL GNU)
  add_compile_options(-Wall -Wextra -Wpointer-arith -Wshadow)
  add_compile_options(-Werror)
  add_compile_options(-fPIC)
elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
  add_compile_options(-Wall -Wextra -Wpointer-arith -Wshadow)
  add_compile_options(-Werror)
  add_compile_options(-fPIC)
endif()

# ---------------------------------------------------------------------------
# gtirb
# ---------------------------------------------------------------------------
find_package(gtirb 2.2.0 REQUIRED)

add_definitions(-DGTIRB_WRAP_UTILS_IN_NAMESPACE)

# ---------------------------------------------------------------------------
# Boost
# ---------------------------------------------------------------------------
#
# Note: we would like to use std::filsystem. However, currently, std::filesystem
# is not provided in clang 6 or gcc 7, both of which are the default installed
# versions for Ubuntu 18. Instead in that context, one can use the
# "experimental" version fo filesystem. But we've decided that it's simpler to
# just use boost::filesystem instead until we (eventually) drop support for
# Ubuntu 18.
set(BOOST_COMPONENTS filesystem program_options system)
find_package(Boost 1.67 REQUIRED COMPONENTS ${BOOST_COMPONENTS})

add_compile_options(-DBOOST_CONFIG_SUPPRESS_OUTDATED_MESSAGE)
add_compile_options(-DBOOST_SYSTEM_NO_DEPRECATED)

=== python/CMakeLists.txt ===
function(make_absolute variable path)
  file(READ_SYMLINK "${path}" link_path)
  if(NOT IS_ABSOLUTE "${link_path}")
    get_filename_component(dir "${path}" DIRECTORY)
    set(path "${dir}/${link_path}")
  endif()
  set(${variable}
      "${path}"
      PARENT_SCOPE)
endfunction()

if(GTIRB_PPRINTER_RELEASE_VERSION)
  set(GTIRB_PPRINTER_PYTHON_DEV_SUFFIX "")
else()
  set(GTIRB_PPRINTER_PYTHON_DEV_SUFFIX ".dev")
endif()

# TODO: GTIRB_RELEASE_VERSION or GTIRB_PYTHON_DEV_SUFFIX should come from the
# GTIRB conan files and not get guessed at here.
if(GTIRB_PPRINTER_RELEASE_VERSION)
  set(GTIRB_PYTHON_DEV_SUFFIX "")
else()
  set(GTIRB_PYTHON_DEV_SUFFIX ".dev")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in
               ${CMAKE_CURRENT_BINARY_DIR}/setup.py @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.py.in
               ${CMAKE_CURRENT_BINARY_DIR}/version.py @ONLY)

find_library(GTIRB_LIBRARY_PATH gtirb)
make_absolute(GTIRB_LIBRARY_PATH ${GTIRB_LIBRARY_PATH})

find_library(CAPSTONE_LIBRARY_PATH capstone)
make_absolute(CAPSTONE_LIBRARY_PATH ${CAPSTONE_LIBRARY_PATH})

file(GLOB PY_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/gtirb_pprinter/*.py)

add_custom_target(pypprinter ALL DEPENDS ${PY_SOURCES} gtirb-pprinter)
add_custom_command(
  TARGET pypprinter
  COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/src"
          "${CMAKE_CURRENT_BINARY_DIR}/src"
  COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/README.md"
          "${CMAKE_CURRENT_BINARY_DIR}/"
  COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/version.py"
          "${CMAKE_CURRENT_BINARY_DIR}/src/gtirb_pprinter/"
  COMMAND ${CMAKE_COMMAND} -E make_directory
          "${CMAKE_CURRENT_BINARY_DIR}/src/gtirb_pprinter/.libs/"
  COMMAND
    ${CMAKE_COMMAND} -E copy ${GTIRB_LIBRARY_PATH} ${CAPSTONE_LIBRARY_PATH}
    $<TARGET_FILE:gtirb_layout> $<TARGET_FILE:gtirb_pprinter>
    $<TARGET_SONAME_FILE:gtirb_layout> $<TARGET_SONAME_FILE:gtirb_pprinter>
    "${CMAKE_CURRENT_BINARY_DIR}/src/gtirb_pprinter/.libs/"
  COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtirb-pprinter>
          "${CMAKE_CURRENT_BINARY_DIR}/src/gtirb_pprinter/")
if(UNIX AND NOT APPLE)
  add_custom_command(
    TARGET pypprinter
    COMMAND patchelf --set-rpath '$$ORIGIN/.libs'
            "${CMAKE_CURRENT_BINARY_DIR}/src/gtirb_pprinter/gtirb-pprinter"
    COMMAND patchelf --set-rpath '$$ORIGIN'
            "${CMAKE_CURRENT_BINARY_DIR}/src/gtirb_pprinter/.libs/*")
endif()

# Convenience targets for building the python wheel
find_program(PYTHON3 "python3")
add_custom_target(
  python-wheel
  DEPENDS pypprinter
  COMMAND "${PYTHON3}" setup.py bdist_wheel)

=== src/CMakeLists.txt ===
add_subdirectory(gtirb_layout)
add_subdirectory(gtirb_pprinter)

=== tests/requirements.txt ===
# Requirements for running tests. These should be kept minimal because the
# conanfile runs tests by default.
gtirb
gtirb-test-helpers

=== doc/doxy/CMakeLists.txt ===
# based on sample in https://majewsky.wordpress.com/2010/08/14/tip-of-the-day-
# cmake-and-doxygen/ add a target to generate API documentation with Doxygen

cmake_minimum_required(VERSION 3.3)

find_package(Doxygen 1.8.11)
if(DOXYGEN_FOUND)

  set(DOC_INDIR "${CMAKE_CURRENT_SOURCE_DIR}/..")
  set(ROOTDIR "${CMAKE_CURRENT_SOURCE_DIR}/../..")

  set(BUILDFILES_IN preprocmd.py DoxygenLayout.xml)
  foreach(_inf ${BUILDFILES_IN})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${_inf}
                   ${CMAKE_CURRENT_BINARY_DIR}/${_inf} @ONLY)
  endforeach()

  # Handle version initialization
  file(READ "${ROOTDIR}/version.txt" ver)

  string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
  set(GTIRB_PPRINTER_MAJOR_VERSION ${CMAKE_MATCH_1})

  string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
  set(GTIRB_PPRINTER_MINOR_VERSION ${CMAKE_MATCH_1})

  string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
  set(GTIRB_PPRINTER_PATCH_VERSION ${CMAKE_MATCH_1})

  configure_file("${ROOTDIR}/include/gtirb_pprinter/version.h.in"
                 "${ROOTDIR}/include/gtirb_pprinter/version.h" @ONLY)

  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" @ONLY)

  # adapted from https://gist.github.com/abravalheri/11214134

  macro(move_filename file_list newdir)
    foreach(src_file ${${file_list}})
      get_filename_component(src_file_name "${src_file}" NAME)
      list(REMOVE_ITEM ${file_list} "${src_file}")
      list(APPEND ${file_list} "${newdir}/${src_file_name}")
    endforeach()
  endmacro()

  # ----------------------------------------------------------------------
  # copy md files into the working directory
  # ----------------------------------------------------------------------

  set(MDFILES_IN "${ROOTDIR}/CONTRIBUTING.md" "${ROOTDIR}/gtirb-pprinter.md"
                 "${ROOTDIR}/README.md")

  set(MDFILES ${MDFILES_IN})
  move_filename(MDFILES ${CMAKE_CURRENT_BINARY_DIR})
  # message("MDFILES = ${MDFILES}")

  foreach(_inmd ${MDFILES_IN})
    get_filename_component(_outmd "${_inmd}" NAME)
    add_custom_command(
      OUTPUT ${_outmd}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${_inmd}
      COMMAND ${CMAKE_COMMAND} -E copy ${_inmd} "${_outmd}.in"
      COMMAND python preprocmd.py "${_outmd}.in" ${_outmd}
      COMMENT "processing ${_outmd}"
      VERBATIM)
  endforeach()

  # ----------------------------------------------------------------------
  # Main target
  # ----------------------------------------------------------------------

  add_custom_target(
    doc
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${DOTFILES}
    DEPENDS ${MDFILES}
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    COMMENT "Generating API documentation with Doxygen"
    VERBATIM)
endif(DOXYGEN_FOUND)

=== src/gtirb_layout/CMakeLists.txt ===
set(PROJECT_NAME gtirb_layout)

# headers
configure_file("${CMAKE_SOURCE_DIR}/include/gtirb_layout/version.h.in"
               "${CMAKE_BINARY_DIR}/include/gtirb_layout/version.h" @ONLY)

set(${PROJECT_NAME}_H
    ${CMAKE_SOURCE_DIR}/include/gtirb_layout/gtirb_layout.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_layout/Export.hpp
    ${CMAKE_BINARY_DIR}/include/gtirb_layout/version.h)

# sources
set(${PROJECT_NAME}_SRC gtirb_layout.cpp)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_H} ${${PROJECT_NAME}_SRC})

set_target_properties(
  ${PROJECT_NAME}
  PROPERTIES VERSION ${GTIRB_PPRINTER_VERSION}
             SOVERSION ${GTIRB_PPRINTER_MAJOR_VERSION}
             FOLDER "debloat")

target_link_libraries(${PROJECT_NAME} PUBLIC ${SYSLIBS} ${Boost_LIBRARIES}
                                             gtirb ${CAPSTONE})

# interface
target_include_directories(
  ${PROJECT_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>)
target_include_directories(
  ${PROJECT_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>)
target_include_directories(
  ${PROJECT_NAME}
  PRIVATE $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include/gtirb_layout>)
target_include_directories(
  ${PROJECT_NAME}
  PRIVATE $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include/gtirb_layout>)

# compile options
target_compile_options(${PROJECT_NAME} PRIVATE -D${PROJECT_NAME}_EXPORTS)

install_linux_debug_info(${PROJECT_NAME} layout-debug-file)

# Copy headers into build directory
install(
  TARGETS ${PROJECT_NAME}
  COMPONENT layout_library
  EXPORT gtirb_pprinterTargets
  INCLUDES
  DESTINATION include
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)
install(
  FILES ${${PROJECT_NAME}_H}
  DESTINATION include/gtirb_layout
  COMPONENT layout_headers)

# subdirectories
add_subdirectory(driver)
if(GTIRB_PPRINTER_ENABLE_TESTS)
  add_subdirectory(test)
endif()

=== src/gtirb_pprinter/CMakeLists.txt ===
set(PROJECT_NAME gtirb_pprinter)
# headers
configure_file("${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/version.h.in"
               "${CMAKE_BINARY_DIR}/include/gtirb_pprinter/version.h" @ONLY)

set(${PROJECT_NAME}_H
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/AuxDataSchema.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/AuxDataUtils.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/BinaryPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/Export.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/FileUtils.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/Fixup.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/PrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/Syntax.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/Arm64PrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/ArmPrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/AttPrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/ElfBinaryPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/ElfPrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/ElfVersionScriptPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/IntelPrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/StringUtils.hpp
    ${CMAKE_BINARY_DIR}/include/gtirb_pprinter/version.h
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/MasmPrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/PeBinaryPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/PePrettyPrinter.hpp
    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter/Mips32PrettyPrinter.hpp)

# sources
set(${PROJECT_NAME}_SRC
    ArmPrettyPrinter.cpp
    AuxDataUtils.cpp
    Arm64PrettyPrinter.cpp
    AttPrettyPrinter.cpp
    BinaryPrinter.cpp
    ElfBinaryPrinter.cpp
    ElfPrettyPrinter.cpp
    ElfVersionScriptPrinter.cpp
    FileUtils.cpp
    Fixup.cpp
    IntelPrettyPrinter.cpp
    PrettyPrinter.cpp
    Registration.cpp
    StringUtils.cpp
    Syntax.cpp
    MasmPrettyPrinter.cpp
    PeBinaryPrinter.cpp
    PePrettyPrinter.cpp
    Mips32PrettyPrinter.cpp)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_H} ${${PROJECT_NAME}_SRC})

set_target_properties(
  ${PROJECT_NAME}
  PROPERTIES VERSION ${GTIRB_PPRINTER_VERSION}
             SOVERSION ${GTIRB_PPRINTER_MAJOR_VERSION}
             FOLDER "debloat")

target_link_libraries(${PROJECT_NAME} PUBLIC ${SYSLIBS} ${Boost_LIBRARIES}
                                             gtirb ${CAPSTONE})

# interface

target_include_directories(
  ${PROJECT_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>)
target_include_directories(
  ${PROJECT_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>)
target_include_directories(
  ${PROJECT_NAME}
  PRIVATE $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include/gtirb_pprinter>)
target_include_directories(
  ${PROJECT_NAME}
  PRIVATE $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include/gtirb_pprinter>)

# compile options
target_compile_options(${PROJECT_NAME}
                       PRIVATE -DDEBLOAT_${PROJECT_NAME}_EXPORTS)

install_linux_debug_info(${PROJECT_NAME} pprinter-debug-file)

# Copy headers into build directory
install(
  TARGETS ${PROJECT_NAME}
  COMPONENT pprinter_library
  EXPORT gtirb_pprinterTargets
  INCLUDES
  DESTINATION include
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)
install(
  FILES ${${PROJECT_NAME}_H}
  DESTINATION include/gtirb_pprinter
  COMPONENT pprinter_headers)

# subdirectories
add_subdirectory(driver)
add_subdirectory(test)

=== tests/dummyso_libs/Makefile ===
all:
	gcc -c -fPIC a.s
	ld -o libmya.so -shared a.o
	gcc -c -fPIC b.s
	ld -o libmyb.so -shared b.o

=== src/gtirb_layout/driver/CMakeLists.txt ===
set(BINARY_NAME gtirb-layout)

add_executable(${BINARY_NAME} Logger.h gtirb_layout.cpp)

set_target_properties(${BINARY_NAME} PROPERTIES FOLDER "debloat")

target_link_libraries(
  ${BINARY_NAME} PRIVATE ${SYSLIBS} ${EXPERIMENTAL_LIB} ${Boost_LIBRARIES}
                         ${LIBCPP_ABI} gtirb_layout)

install_linux_debug_info(${BINARY_NAME} layout-driver-debug-file)

install(
  TARGETS ${BINARY_NAME}
  DESTINATION bin
  COMPONENT layout_driver)

if(GTIRB_PPRINTER_STATIC_DRIVERS)
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
    # We do not want to statically link in the STL here, as MSVC is a bit
    # prickly about STL ABIs.
  else()
    target_link_libraries(${BINARY_NAME} PRIVATE -static-libstdc++
                                                 -static-libgcc)
  endif()
endif()

=== src/gtirb_layout/test/CMakeLists.txt ===
set(PROJECT_NAME TestGtirbLayout)

include_directories(${GTEST_INCLUDE_DIRS})

set(${PROJECT_NAME}_H)

set(${PROJECT_NAME}_SRC layout_test.cpp)

if(UNIX AND NOT WIN32)
  set(SYSLIBS dl)
else()
  set(SYSLIBS)
endif()

add_executable(${PROJECT_NAME} ${${PROJECT_NAME}_SRC})
target_link_libraries(${PROJECT_NAME} ${SYSLIBS} ${Boost_LIBRARIES} gtest gtirb
                      gtirb_layout)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== src/gtirb_pprinter/driver/CMakeLists.txt ===
set(PRETTY_PRINTER gtirb-pprinter)

add_executable(
  ${PRETTY_PRINTER} Logger.h parser.hpp parser.cpp printing_paths.hpp
                    printing_paths.cpp pretty_printer.cpp)

set_target_properties(${PRETTY_PRINTER} PROPERTIES FOLDER "debloat")

target_link_libraries(
  ${PRETTY_PRINTER} PRIVATE ${SYSLIBS} ${EXPERIMENTAL_LIB} ${Boost_LIBRARIES}
                            ${LIBCPP_ABI} gtirb_pprinter gtirb_layout)

install_linux_debug_info(${PRETTY_PRINTER} pprinter-driver-debug-file)

install(
  TARGETS ${PRETTY_PRINTER}
  DESTINATION bin
  COMPONENT pprinter_driver)

if(GTIRB_PPRINTER_STATIC_DRIVERS)
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
    # We do not want to statically link in the STL here, as MSVC is a bit
    # prickly about STL ABIs.
  else()
    target_link_libraries(${PRETTY_PRINTER} PRIVATE -static-libstdc++
                                                    -static-libgcc)
  endif()
endif()

=== src/gtirb_pprinter/test/CMakeLists.txt ===
set(PROJECT_NAME TestNameParser)

include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${CMAKE_SOURCE_DIR}/include
                    ${CMAKE_SOURCE_DIR}/include/gtirb_pprinter)

set(${PROJECT_NAME}_SRC
    parser_test.cpp
    libraries_test.cpp
    test_main.cpp
    ../driver/parser.hpp
    ../driver/parser.cpp
    ../driver/printing_paths.hpp
    ../driver/printing_paths.cpp)

if(UNIX AND NOT WIN32)
  set(SYSLIBS dl)
else()
  set(SYSLIBS)
endif()

add_executable(${PROJECT_NAME} ${${PROJECT_NAME}_SRC})
target_link_libraries(${PROJECT_NAME} ${SYSLIBS} ${Boost_LIBRARIES} gtest
                      gtirb_pprinter)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== .ci/PKGBUILD ===
# Contributor: Eric Schulte <eschulte@grammatech.com>
# Maintainer: Eric Schulte <eschulte@grammatech.com>
_srcname=gtirb-pprinter
pkgname=gtirb-pprinter-git
pkgver=v0.1.1.r248.g48aa1e6
pkgrel=1
pkgdesc="Pretty printer from GTIRB to assembly code"
arch=('x86_64')
# url="https://github.com/grammatech/gtirb-pprinter"
url="https://git.grammatech.com/rewriting/gtirb-pprinter#print-modules-in-windows"
license=('MIT')
optdepends=('boost: build against system boost')
depends=()
makedepends=('git' 'cmake' 'gtirb' 'capstone' 'python' 'doxygen' 'graphviz')
provides=('gtirb-pprinter')
source=('git://github.com/grammatech/gtirb-pprinter.git')
sha512sums=('SKIP')

pkgver() {
  cd "$_srcname"
  git describe --long --tags | sed 's/\([^-]*-g\)/r\1/;s/-/./g'
}

build() {
    cd "$_srcname/"
    cmake ./ -Bbuild -DCMAKE_INSTALL_PREFIX=/usr \
      -DCMAKE_BUILD_TYPE=${BUILD_TYPE-RelWithDebInfo} \
      -DCMAKE_CXX_COMPILER=${COMPILER-g++}
    cmake --build build
    # Build Docs
    cmake doc/doxy/ -Bbuild-doc
    cmake --build build-doc --target doc
}

package() {
  cd "$_srcname/"
  make -Cbuild DESTDIR="$pkgdir" install
  mkdir -p "$pkgdir"/usr/share/doc/$_srcname
  cp -R build-doc/html/ "$pkgdir"/usr/share/doc/$_srcname
}
